# PHEW: Paths with higher edge-weights give ``winning tickets'' without training data

This repository is the official implementation of [PHEW: Paths with higher edge-weights give ``winning tickets'' without training data]

## Requirements

Intended for Ubuntu 18.04 and Python3-dev
Libraries :

torch, torchvision, numpy, copy, random

## Results

Our model achieves the following performance on :

### Classification
#### [VGG19 on CIFAR-10]

| Model name         | 90% Pruning | 95% Pruning | 98% Pruning | 
| ------------------ | ----------- | ----------- | ----------- | 
|       PHEW         | 93.80(0.08) | 93.18(0.14) | 92.24(0.18) |     

#### [VGG19 on CIFAR-100]

| Model name         | 90% Pruning | 95% Pruning | 98% Pruning | 
| ------------------ | ----------- | ----------- | ----------- | 
|       PHEW         | 73.30(0.11) | 72.51(0.13) | 69.17(0.26) |  

#### [ResNet-34 on CIFAR-10]

| Model name         | 90% Pruning | 95% Pruning | 98% Pruning | 
| ------------------ | ----------- | ----------- | ----------- | 
|       PHEW         | 95.13(0.13) | 94.87(0.11) | 93.86(0.22) |  


#### [ResNet-34 on CIFAR-100]

| Model name         | 90% Pruning | 95% Pruning | 98% Pruning | 
| ------------------ | ----------- | ----------- | ----------- | 
|       PHEW         | 76.82(0.23) | 75.87(0.34) | 73.22(0.37) |  


